/***************************************************************************
                          soundbox.cpp  -  description
                             -------------------
    begin                : Sat Mar 9 2002
    copyright            : (C) 2002 by Sebastian Schildt
    email                : sebastian@frozenlight.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "soundbox.h"

SoundBox::SoundBox() {
	KStandardDirs ksd;

	QString str = ksd.findResource("data","ksetisaver/err.wav");
	err = new KAudioPlayer(str);

	str = ksd.findResource("data","ksetisaver/beep2.wav");
  beep1 = new KAudioPlayer(str);

  str = ksd.findResource("data","ksetisaver/beep1.wav");
  beep2 = new KAudioPlayer(str);
}

SoundBox::~SoundBox(){
}

void SoundBox::playErr() const {
 if(enabled) { err->play(); }
}

void SoundBox::playBeep1() const {
 if(enabled) {
		beep1->play();
		//cout << "Beep" << endl;
 }
}

void SoundBox::playBeep2() const {
 if(enabled) {
		beep2->play();
		//cout << "Beep" << endl;
 }
}

void SoundBox::setEnabled(bool e) {
 enabled=e;
}
